> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/en/development-guide/nodejs/user-identifier/node-user-info-crm.md).

# CRM Properties

CRM Properties are stored securely only on the Hackle server and cannot be directly retrieved through the SDK.

{% hint style="danger" %}
CRM Properties are managed separately and are not deleted or reset when `resetUser()` is called or when `clearAll` is called in `updateUserProperties`.

When a user withdraws their membership, you must separately call the provided function to delete the information.
{% endhint %}

## Phone Number Collection

{% hint style="danger" %}
The Node.js SDK does not provide phone number collection functionality.

You can perform [phone number collection and deletion](/en/development-guide/http-api/api-properties.md) using the HTTP API.
{% endhint %}

## CRM Marketing Subscription Consent

{% hint style="info" %}
For details about subscription consent status, refer to the [CRM Message Subscription Consent Management documentation](/en/development-guide/sdk/user-identifier/crm-subscription.md).
{% endhint %}

### Subscription Consent Properties

You can consent to or opt out of subscriptions per message purpose.

Use `HackleSubscriptionOperationsBuilder` to set the consent status for the desired properties, then perform the final update using a method like `updatePushSubscriptions()`.

You can update the consent status per message channel.

```javascript
import { HackleSubscriptionOperationsBuilder } from "@hackler/javascript-sdk";

const user = {
  userId: "143",
  deviceId: "ae2182e0",
};

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build();

hackleClient.updatePushSubscriptions(operations, user);
```

#### Promotional Messages

Set the subscription consent property for promotional messages.

```javascript
import { HackleSubscriptionOperationsBuilder } from "@hackler/javascript-sdk";

const user = {
  userId: "143",
  deviceId: "ae2182e0",
};

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .build();

hackleClient.updatePushSubscriptions(operations, user);
```

#### Informational Messages

Set the subscription consent property for informational messages.

```javascript
import { HackleSubscriptionOperationsBuilder } from "@hackler/javascript-sdk";

const user = {
  userId: "143",
  deviceId: "ae2182e0",
};

const operations = new HackleSubscriptionOperationsBuilder()
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build();

hackleClient.updatePushSubscriptions(operations, user);
```

<table><thead><tr><th width="224.09765625">HackleSubscriptionStatus</th><th>Description</th></tr></thead><tbody><tr><td><code>UNKNOWN</code></td><td>Subscription Consent has not been given or denied (<code>default</code>)</td></tr><tr><td><code>SUBSCRIPTION</code></td><td>Explicitly opted in to receive messages</td></tr><tr><td><code>UNSUBSCRIPTION</code></td><td>Explicitly opted out of receiving messages</td></tr></tbody></table>

### Update Push Subscription Consent Status

Update the push message subscription consent status for the user.

```javascript
import { HackleSubscriptionOperationsBuilder } from "@hackler/javascript-sdk";

const user = {
  userId: "143",
  deviceId: "ae2182e0",
};

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build();

hackleClient.updatePushSubscriptions(operations, user);
```

### Update Kakao Message Subscription Consent Status

Update the Kakao Message subscription consent status for the user.

```javascript
import { HackleSubscriptionOperationsBuilder } from "@hackler/javascript-sdk";

const user = {
  userId: "143",
  deviceId: "ae2182e0",
};

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build();

hackleClient.updateKakaoSubscriptions(operations, user);
```

### Update Text Message Subscription Consent Status

Update the text message subscription consent status for the user.

```javascript
import { HackleSubscriptionOperationsBuilder } from "@hackler/javascript-sdk";

const user = {
  userId: "143",
  deviceId: "ae2182e0",
};

const operations = new HackleSubscriptionOperationsBuilder()
  .marketing(HackleSubscriptionStatus.SUBSCRIBED)
  .information(HackleSubscriptionStatus.SUBSCRIBED)
  .build();

hackleClient.updateSmsSubscriptions(operations, user);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hackle.io/en/development-guide/nodejs/user-identifier/node-user-info-crm.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
